'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.map = map;

var _ship = require('./ship');

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var _marked = [mapCommand, mapWithAnswer].map(regeneratorRuntime.mark);

function mapCommand(liftEffect, liftCommit, extractState, command) {
  var _this = this;

  var _ret;

  return regeneratorRuntime.wrap(function mapCommand$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          _context2.t0 = command.type;
          _context2.next = _context2.t0 === 'Effect' ? 3 : _context2.t0 === 'Commit' ? 5 : _context2.t0 === 'GetState' ? 7 : 11;
          break;

        case 3:
          return _context2.delegateYield(liftEffect(command.effect), 't1', 4);

        case 4:
          return _context2.abrupt('return', _context2.t1);

        case 5:
          return _context2.delegateYield((0, _ship.commit)(liftCommit(command.commit)), 't2', 6);

        case 6:
          return _context2.abrupt('return', _context2.t2);

        case 7:
          return _context2.delegateYield(regeneratorRuntime.mark(function _callee() {
            var selector;
            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    selector = command.selector;
                    return _context.delegateYield((0, _ship.getState)(function (state) {
                      return selector(extractState(state));
                    }), 't0', 2);

                  case 2:
                    _context.t1 = _context.t0;
                    return _context.abrupt('return', {
                      v: _context.t1
                    });

                  case 4:
                  case 'end':
                    return _context.stop();
                }
              }
            }, _callee, _this);
          })(), 't3', 8);

        case 8:
          _ret = _context2.t3;

          if (!((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object")) {
            _context2.next = 11;
            break;
          }

          return _context2.abrupt('return', _ret.v);

        case 11:
          return _context2.abrupt('return', command);

        case 12:
        case 'end':
          return _context2.stop();
      }
    }
  }, _marked[0], this);
}

function mapWithAnswer(liftEffect, liftCommit, extractState, ship, answer) {
  var result, newAnswer, _newAnswer;

  return regeneratorRuntime.wrap(function mapWithAnswer$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          result = ship.next(answer);

          if (!result.done) {
            _context3.next = 3;
            break;
          }

          return _context3.abrupt('return', result.value);

        case 3:
          _context3.t0 = result.value.type;
          _context3.next = _context3.t0 === 'Command' ? 6 : _context3.t0 === 'All' ? 10 : 14;
          break;

        case 6:
          return _context3.delegateYield(mapCommand(liftEffect, liftCommit, extractState, result.value.command), 't1', 7);

        case 7:
          newAnswer = _context3.t1;
          return _context3.delegateYield(mapWithAnswer(liftEffect, liftCommit, extractState, ship, newAnswer), 't2', 9);

        case 9:
          return _context3.abrupt('return', _context3.t2);

        case 10:
          return _context3.delegateYield(_ship.allAny.apply(undefined, _toConsumableArray(result.value.ships.map(function (currentShip) {
            return mapWithAnswer(liftEffect, liftCommit, extractState, currentShip);
          }))), 't3', 11);

        case 11:
          _newAnswer = _context3.t3;
          return _context3.delegateYield(mapWithAnswer(liftEffect, liftCommit, extractState, ship, _newAnswer), 't4', 13);

        case 13:
          return _context3.abrupt('return', _context3.t4);

        case 14:
          return _context3.abrupt('return', result.value);

        case 15:
        case 'end':
          return _context3.stop();
      }
    }
  }, _marked[1], this);
}

function map(liftCommit, extractState, ship) {
  return mapWithAnswer(function (effect) {
    return (0, _ship.call)(effect);
  }, liftCommit, extractState, ship);
}